// HndGoDrcCompute.h 

//-------------------------------
// Variables for DRC handling
//-------------------------------

	#define StackElements 128	// Max stack length
	#define RPNElements 128	// Max # of RPN Elements
	
	// defines of operators
	#define LAND 0			// Logical AND (&&)
	#define LOR 1			// Logical OR (||)
	#define NOT 2			// Not (!)
	#define EQU 3			// Equal (==)
	#define LTE 4			// Less than or equal (<=)
	#define GTE 5			// Greater than or equal (>=)
	#define NTE 6			// Not equal (!=)
	#define SHL 7			// Bitwise shift left (<<)
	#define SHR 8			// Bitwise shift right (>>)
	#define INVERT 9		// Invert (~)
	#define BAND 10			// Bitwise AND (&)
	#define BOR 11			// Bitwise OR (|)
	#define BXOR 12			// Bitwise XOR (^)
	#define PLUS 13			// Plus (+)
	#define MINUS 14		// Minus (-)
	#define MPLY 15			// Multiply (*)
	#define DIVD 16			// Divide (/)
	#define MODULO 17		// Modulo (%)
	
	#define rpnC 18			// RPN's c variable
	#define rpnI 19			// RPN's i variable
	#define rpnKEY 20		// RPN's KEY variable
	
	// Integer Array for stack emulation
	int stack[StackElements];
	// Stack watermark
	int wmk = 0;

	// Integer array for RPN elements values storing
	int RPN[RPNElements];
	// Integer array for RPN elements kind storing
	int RPNk[RPNElements];
	// RPN elements kind designators
	#define OPERAND 1
	#define OPERATOR 2
	
	// RPN watermark
	int RPNwmk = 0;

	// Pointer to parsed CDUI String
	pointer pCDUI;
	
	// Global variables for DRC Computation
	int I, C, KEY;
	
	// Stores CDUI Length
	int CDUILth;

