// HndGoDrc Functions

//------------------------------------
// Standard functions
//------------------------------------

// CHECKFORTABLES
// Verifies Tables existence, otherwise creates them.
CheckForTables() {
int c, rc, first;
pointer PtrData;
	if (!dbopen(FormulaDBName)) {
		first = True;
		alert("It's the first time you run HndGoDrc. Let's create some internal PDB...");
	}
	// Verifies Formula DB
	if (!dbopen(FormulaDBName)) {
		// Create with Creator e User
		rc = dbcreate(FormulaDBName);
		PtrData = malloct(1, MskTableDB);
		PtrData[0] = "i 0 == 111 * key + c 2 * +";
		dbrec(-1);
		dbwritex(PtrData, MskTableDB);	
		dbbackup(1);
		dbclose();
	} else {
		// Set Recno for Browse
		FormulaDBRecno = dbnrecs();
		// Open OK
		dbbackup(1);
		dbclose();
	}
	
	// Verifies CDUI
	if (!dbopen(CDUIDBName)) {
		// Create with Creator e User
		rc = dbcreate(CDUIDBName);
		PtrData = malloct(1, MskTableDB);
		PtrData[0] = "Will P";
		dbrec(-1);
		dbwritex(PtrData, MskTableDB);	
		dbbackup(1);
		dbclose();
	} else {
		// Imposta il suo Recno x Browse
		CDUIDBRecno = dbnrecs();
		// Open OK
		dbbackup(1);
		dbclose();
	}
	if (first) {
		first = False;
		alert("Done. Internal PDB were created.");
	}
}

// STRINGCHOP
// Truncates the string at NumPixel length
string StringChop (string InString, int NumPixel) {
int SlenChr, SlenPxl, c;
	SlenChr = strlen(InString);
	SlenPxl = textwidth(InString);
	if (SlenPxl < NumPixel) {
		return (InString);
	}
	while (SlenPxl > NumPixel) {
		SlenPxl = textwidth(substr(InString, 0, SlenChr--));
	}
	return (substr(InString, 0, SlenChr));
}

// PLEASEDESTROYTB
// Destroys CurrentTable
PleaseDestroyTB() {
	if(ATableWasBuilt) {
		free(PtrDataTB);
		Chide(fStn_iTableItems);
		Cdestroy(fStn_iTableItems);
		ATableWasBuilt = False;
	}
}

// SHOWTABLE
// Shows table in CurrentTable
ShowTable(int CurrentTable) {
int Recno;
	switch(CurrentTable) {
		case Formulas:
			dbopen(FormulaDBName);
			break;
		case CDUI:
			dbopen(CDUIDBName);
			break;
	}
	// Shows elements dinamically
	Recno=dbnrecs();
	if (Recno == 0) {
		// No record, do not build
		alert("This table has no records...");
		ATableWasBuilt = False;
	} else {
		// Sets building flag
		ATableWasBuilt = True;
		// Checks how to show the table
		if (Recno > 9) {
			Recno = 9;
		}
		PtrDataTB = malloct(1, MskTableDB);
		fStn_iTableItems=CtableDB(0,30,161, Recno, 1, PtrDataTB, "sz");
		Csetrow(fStn_iTableItems, 0, 161, 0);
		Cdraw(fStn_iTableItems);
	}
}	

// STARTUP
// Startup Application
Startup() {
int c;	
	// Veryfies DB or creates it
	CheckForTables();
	
	// Start Menu' handling
	Mbar=Cmenubar();
	
	Info=Cmenu(5,80,35);
	Caddmenu(Mbar,Info);
	Csettopic(Info,"Info");
	Cadditem(Info,"About");
}	

// DDN_ADDITEM
// Loads Elements with a certain lenght...
ddn_AddItem(int Control, int PxlLen) {
pointer PtrData;
int c, nrec;
string ItemToAdd;
	PtrData = malloct(1, MskTableDB);
	switch (Control) {
		case Formulas:
			dbopen(FormulaDBName);
			break;
		case CDUI:
			dbopen(CDUIDBName);
			break;
		default:
	}
	nrec = dbnrecs();
	for (c=0; c<nrec; c++) {
		dbrec(c);
		dbreadx(PtrData, MskTableDB);	
		ItemToAdd = PtrData[0];
		// Sets element length accordingly
		if (textwidth(ItemToAdd) > (PxlLen)) {
			ItemToAdd = StringChop(ItemToAdd, (PxlLen-5));
			ItemToAdd = ItemToAdd + "...";
		}
		// Aggiunge Elemento
		switch (Control) {
			case Formulas:
				Cadditem(fCmp_ddnRPN, ItemToAdd);
				break;
			case CDUI:
				Cadditem(fCmp_ddnCDUI, ItemToAdd);
				break;
			default:
		}
	}
	switch (Control) {
		case Formulas:
			Csetcursel(fCmp_ddnRPN, 0);
		case CDUI:
			Csetcursel(fCmp_ddnCDUI, 0);
		default:
	}
	dbclose();
	free(PtrData);
}

// HndGo
// SplashScreen
//
HndGo(){
return "93000000000000000000000000000000000000000000000000000000000000000000000000000080000000000000000000000000000000000048800000000000000000000000000000000007f00000000000000000000000000000000000270000000000000000000000000000000000022000000000000000000000000000" + 
  "0000000063c00000000000000000000000000000000001e0000000000000000000000000000000000032000000000000000000000000000000000007200000000000000000000000000000000000e000000000000000000000000000000000000e000000000000000000000000000000000001e000000000000000000000000" + 
  "000000000001e000000000000000000000000000000000001e000000000000000000000000000000000003e000000000000000000000000000000000003e000000000000000000000000000000000003e060000000000000000000000000000000003e1f0000000000000000000000000000000003e1f000000000000000000" + 
  "0000000000000003f3f8000000000000000000000000000000003f3f8000000000000000000000000000000003fbf8000000000000000000000000000000003fbf8000000000000000000000000000000003fdf0000000000000000000000000000000003fee0000000000000000000000000000000003ff000000000000000" + 
  "00000000000000000001ff00000000000000000000000000000000001ff80000000000000000000000000000000001ffc0000000000000000000000000000000001ffe0000000000000000000000000000000000fff0000000000000000000000000000000000fff0000000000000000000000000000000000fff8000000000" + 
  "000003c00000000000000000fff87f87f8000000003c000000000000000007ffc3f03f0000000001c000000000000000007ffc0e01c0000000000c000000000000000007ffc0e01c0000000000c000000000000000007ffe0e01c0000000000c000000000000000007ffe0e01c07839f803ec0f839f803e20f00003ffe0e01c" + 
  "1fe3ffe0ffc3fe3ffe0ffe3fc3403ffe0e01c1cf0fff1ffc39e0fff1e3e7fe1c03efe0e01c3870f0f1c3c70f0f0f1c1870f1c03efe0fffc3070e073c1c6070e071c1ce070003e7e0e01c0070e07381c00f0e071c1ce078003e7e0e01c0ff0e07381c0ff0e071c1cc038003e7e0e01c1ff0e07381c1ff0e071c38c038003c7e0" + 
  "e01c3c70e07381c3870e070ff0c038007c3c0e01c7870e07381c7070e0707c0e078007c3c0e01c7070e073c1c7070e070c00e07000783c0e01c78f0e073c3c70f0e071c00f0f000783c0e01c7ff0e071ffe7ff0e071ff87ff00070387f87fbffff9fcfff3ffff9f8ffc3fe00060387f87f9e3df9fc7cf1e7bf9f8e3e0f8000e" + 
  "038000000000000000000000001c0e000000c03000000000000000000000000380e000000807000000000000000000000000380e0000000060000000000000000000000001c0c0000000060000000000000000000000001ffc00000000400000000000000000000000007f00000000000000000000000000000000000000000" + 
  "000000000000000000000000000000000000000";
}


